unit ana_unite;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons,
  IniFiles, DB, DBTables, ADODB, ComCtrls, Base64, ExtCtrls, Menus, ADOInt,
  Tanimlamalar;

type
  TAnaForm = class(TForm)
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    PreviousStageSpeedButton: TSpeedButton;
    NextStageSpeedButton: TSpeedButton;
    SpeedButton8: TSpeedButton;
    TabSheet5: TTabSheet;
    SpeedButton7: TSpeedButton;
    ScheduleSpeedButton: TSpeedButton;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    Label4: TLabel;
    Label5: TLabel;
    db_path: TEdit;
    password: TEdit;
    Memo1: TMemo;
    Memo2: TMemo;
    CheckBox1: TCheckBox;
    Memo3: TMemo;
    Label2: TLabel;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    Label3: TLabel;
    LocalTablesListBox: TListBox;
    RemoteTablesListBox: TListBox;
    Memo4: TMemo;
    GroupBox4: TGroupBox;
    Label8: TLabel;
    ConverStatusLabel: TLabel;
    ConvertProgressBar: TProgressBar;
    Memo5: TMemo;
    GroupBox5: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    ProgressBar2: TProgressBar;
    Memo6: TMemo;
    Bevel1: TBevel;
    Label6: TLabel;
    Label11: TLabel;
    PopupMenu1: TPopupMenu;
    asdsdasd1: TMenuItem;
    asd1: TMenuItem;
    as1: TMenuItem;
    da1: TMenuItem;
    sd1: TMenuItem;
    as2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpeedButton8Click(Sender: TObject);
    procedure NextStageSpeedButtonClick(Sender: TObject);
    procedure PreviousStageSpeedButtonClick(Sender: TObject);
    procedure TabSheet2Show(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton6Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
    FConnection: _Connection;
    FRecordset: _Recordset;
  public
    { Public declarations }
  end;

var
  AnaForm: TAnaForm;

implementation

{$R *.dfm}



//------------------------------------------------------------------------------

procedure Save_Settings;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create( ChangeFileExt( Application.ExeName, '.INI' ) );
  Ini.WriteString('General','db_path',Encode64(AnaForm.db_path.Text));
  Ini.WriteString('General','value',Encode64(AnaForm.password.Text));
  Ini.WriteString('General','local_tables',Encode64(AnaForm.LocalTablesListBox.Items.Text));
  Ini.WriteString('General','remote_tables',Encode64(AnaForm.RemoteTablesListBox.Items.Text));
  Ini.Free;
end;

//------------------------------------------------------------------------------

procedure Load_Settings;
var
  Ini: TIniFile;
begin
  Ini := TIniFile.Create( ChangeFileExt( Application.ExeName, '.INI' ) );
  AnaForm.db_path.Text := Decode64(Ini.ReadString('General','db_path',''));
  AnaForm.password.Text := Decode64(Ini.ReadString('General','value','JK5LHKH7KqHLLKbIL4u')); //MAUEDGSDUUIRTN
  AnaForm.LocalTablesListBox.Items.Text := Decode64(Ini.ReadString('General','local_tables',''));
  AnaForm.RemoteTablesListBox.Items.Text := Decode64(Ini.ReadString('General','remote_tables',''));
  Ini.Free;
end;

//------------------------------------------------------------------------------

function Verify_DB_Info: Boolean;
var
  ConnectionString : String;
  AConnection : TADOConnection;
  ADataset : TADODataset;
  AQuery : TADOQuery;
  StringList : TStringList;
begin
  try
    ConnectionString :='Provider=Microsoft.Jet.OLEDB.4.0;'+
    'Data Source='+AnaForm.db_path.Text+';'+
    'Mode=Share Deny None;'+
    'Persist Security Info=false;'+
    'Jet OLEDB:Database Password='+AnaForm.password.Text+';';
    AConnection := TADOConnection.Create(nil);
    AConnection.ConnectionString := ConnectionString;
    AConnection.Open;

    StringList := TStringList.Create;
    AConnection.GetTableNames(StringList);
    result := True;
    AConnection.Close;

  except
     ShowMessage('Veri taban bilgileri yanl. Ltfen girdiiniz bilgileri kontrol edin.');
     result := False;
  end;
end;
//------------------------------------------------------------------------------
procedure TAnaForm.FormCreate(Sender: TObject);
begin

end;

//-----------------------------------------------------------------------------

procedure TAnaForm.SpeedButton1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  db_path.Text := OpenDialog1.FileName;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Save_Settings;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.SpeedButton8Click(Sender: TObject);
begin
  AnaForm.Close;
end;

//-----------------------------------------------------------------------------

procedure Convert_DB;
var
  ConnectionString  : string;
  AConnection       : TADOConnection;
  ADataset          : TADODataset;
  AQuery            : TADOQuery;
  i,j,k             : Integer;
  TotalRecordsCount : Integer;
  TableName         : string;
  FieldNames        : string;
  RecordsCount      : Integer;
  FieldValues       : string;
  SQLList           : TStringList; 

begin
  TotalRecordsCount := 0;  
  // Seilen tablolardaki kaytlar SQL dosyasna yazlacak.
  ConnectionString :='Provider=Microsoft.Jet.OLEDB.4.0;'+
  'Data Source='+AnaForm.db_path.Text+';'+
  'Mode=Share Deny None;'+
  'Persist Security Info=false;'+
  'Jet OLEDB:Database Password='+AnaForm.password.Text+';';
  AConnection := TADOConnection.Create(nil);
  AConnection.ConnectionString := ConnectionString;
  AConnection.Open;

  SQLList := TStringList.Create;
  AQuery := TADOQuery.Create(nil);
  AQuery.Connection := AConnection;
  for i := 0 to AnaForm.RemoteTablesListBox.Items.Count - 1 do
  begin

    AnaForm.ConverStatusLabel.Caption := 'Dntrlen Tablo: '
    + IntToStr(i+1) + ' / ' + IntToStr(AnaForm.RemoteTablesListBox.Items.Count);

    // lem yaplacak tablo ve alanlar hazrlanyor
    TableName := AnaForm.RemoteTablesListBox.Items[i];
    FieldNames := '';
    for k := 1 to 87 do
      if TableName = TablesAndFields[k][1] then
      FieldNames := FieldNames + TablesAndFields[k][2] + ',';
    FieldNames := Copy(FieldNames, 1, Length(FieldNames) - 1);
    TableName[1] := UpCase(TableName[1]);

    // Tm kaytlar veri tabanndan ekiliyor
    AQuery.Close;
    AQuery.SQL.Text := 'Select ' + FieldNames + ' from ' + TableName;
    AQuery.Open;
    AQuery.Recordset.MoveFirst;

    // SQL dosyas oluturuluyor
    RecordsCount := AQuery.Recordset.RecordCount;
    AnaForm.ConvertProgressBar.Max := RecordsCount;
    for j := 1 to RecordsCount do
    begin
      Inc(TotalRecordsCount);
      FieldValues := '';
      for k := 0 to AQuery.Recordset.Fields.Count - 1 do
        FieldValues := FieldValues + '''' + VarToStr(AQuery.Recordset.Fields[k].Value) + ''',';
        FieldValues := Copy(FieldValues, 1, Length(FieldValues) - 1);

      // INSERT cmlesi oluturuluyor         
      SQLList.Add('insert into ' + TableName + ' (' + FieldNames + ') values (' + FieldValues + ');');
      AQuery.Recordset.MoveNext;
      AnaForm.ConvertProgressBar.Position := j;
      Application.ProcessMessages;
    end;
  end;

  AnaForm.ConverStatusLabel.Caption := IntToStr(TotalRecordsCount) + ' adet kayt dntrld.';
  AnaForm.ConvertProgressBar.Position := 1;
  
  // Balantlar kapatlyor ve nesneler hafzadan kaldrlyor
  AQuery.Recordset.Close;
  AQuery.Close;
  AQuery.Free;
  AConnection.Close;
  AConnection.Free;

  // SQL cmleleri SQL dosyasna yazlyor
  SQLList.SaveToFile( ChangeFileExt( Application.ExeName, '.sql'));
  SQLList.Free;  
end;

//-----------------------------------------------------------------------------

procedure Upload_DB;
begin
end;

//-----------------------------------------------------------------------------

procedure ConvertAndUpload;
begin
  Convert_DB;
  Upload_DB;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.NextStageSpeedButtonClick(Sender: TObject);
var
  ActInd : Integer;
begin

  if not Verify_DB_Info then Exit;

  if NextStageSpeedButton.Caption = 'Bala' then
  ConvertAndUpload;

  ActInd := PageControl1.ActivePageIndex;
  if (ActInd + 1) < PageControl1.PageCount-2 then
  begin
  PageControl1.ActivePageIndex := ActInd + 1;
  PreviousStageSpeedButton.Enabled := True;
  end;

  if (ActInd + 1) >= PageControl1.PageCount-3 then
  NextStageSpeedButton.Caption := 'Bala';

end;

//-----------------------------------------------------------------------------

procedure TAnaForm.PreviousStageSpeedButtonClick(Sender: TObject);
var
  ActInd : Integer;
begin
  ActInd := PageControl1.ActivePageIndex;
  if (ActInd - 1) >= 0 then
  begin
  PageControl1.ActivePageIndex := ActInd - 1;
  if PageControl1.ActivePageIndex <> 0 then
  NextStageSpeedButton.Enabled := True
  else NextStageSpeedButton.Enabled := True;
  end;

  if PageControl1.ActivePageIndex = 0 then
  PreviousStageSpeedButton.Enabled := False;

end;

//-----------------------------------------------------------------------------

procedure TAnaForm.TabSheet2Show(Sender: TObject);
var
  ConnectionString : String;
  AConnection : TADOConnection;
  ADataset : TADODataset;
  AQuery : TADOQuery;
begin

  ConnectionString :='Provider=Microsoft.Jet.OLEDB.4.0;'+
  'Data Source='+db_path.Text+';'+
  'Mode=Share Deny None;'+
  'Persist Security Info=false;'+
  'Jet OLEDB:Database Password='+password.Text+';';
  AConnection := TADOConnection.Create(nil);
  AConnection.ConnectionString := ConnectionString;
  AConnection.Open;
  if RemoteTablesListBox.Items.Text = '' then
  AConnection.GetTableNames(LocalTablesListBox.Items);
  AConnection.Close;
end;

//-----------------------------------------------------------------------------

function IsPrivate(str_:String):Boolean;
var i: Byte;
begin
  result := false;
  for i := 1 to 87 do
  if TablesAndFields[i,1] = str_ then
  result := true;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.SpeedButton3Click(Sender: TObject);
var
  i : byte;
begin
  if LocalTablesListBox.Items.Text <> '' then
    for i := LocalTablesListBox.Items.Count-1 downto 0 do
      if IsPrivate(LocalTablesListBox.Items[i])  then
      begin
        RemoteTablesListBox.Items.Add(LocalTablesListBox.Items[i]);
        LocalTablesListBox.Items.Delete(i);
        Application.ProcessMessages;
        Sleep(1);
      end;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.SpeedButton6Click(Sender: TObject);
var
  i : byte;
begin
  if RemoteTablesListBox.Items.Text <> '' then
    for i := RemoteTablesListBox.Items.Count-1 downto 0 do
      if IsPrivate(RemoteTablesListBox.Items[i])  then
      begin
        LocalTablesListBox.Items.Add(RemoteTablesListBox.Items[i]);
        RemoteTablesListBox.Items.Delete(i);
        Application.ProcessMessages;
        Sleep(1);
      end;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.SpeedButton4Click(Sender: TObject);
begin
  if LocalTablesListBox.ItemIndex <> -1 then
  if IsPrivate(LocalTablesListBox.Items[LocalTablesListBox.ItemIndex]) then
  begin
  RemoteTablesListBox.Items.Add(
  LocalTablesListBox.Items[LocalTablesListBox.ItemIndex]);
  LocalTablesListBox.Items.Delete(LocalTablesListBox.ItemIndex);
  end;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.SpeedButton5Click(Sender: TObject);
begin
  if RemoteTablesListBox.ItemIndex <> -1 then
  if IsPrivate(RemoteTablesListBox.Items[RemoteTablesListBox.ItemIndex]) then
  begin
  LocalTablesListBox.Items.Add(
  RemoteTablesListBox.Items[RemoteTablesListBox.ItemIndex]);
  RemoteTablesListBox.Items.Delete(RemoteTablesListBox.ItemIndex);
  end;
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.BitBtn1Click(Sender: TObject);
begin
showmessage(decode64(password.Text));
end;

//-----------------------------------------------------------------------------

procedure TAnaForm.FormShow(Sender: TObject);
begin
  Load_Settings;
end;

end.

{
procedure ShellFileOperation(fromFile: string; toFile: string; Flags: Integer);
var
  shellinfo: TSHFileOpStructA;
begin
  with shellinfo do
  begin
    wnd   := Application.Handle;
    wFunc := Flags;
    pFrom := PChar(fromFile);
    pTo   := PChar(toFile);
    p
  end;
  SHFileOperation(shellinfo);
end;


procedure TAnaForm.Button1Click(Sender: TObject);
begin
    ShellFileOperation('c:\1.zip', 'd:\1.zip', FO_COPY);
  // To Move a file: FO_MOVE
end;

}